# uip/psock.h File Reference

## Detailed Description

Protosocket library header file.

Author:
  Adam Dunkels <adam@sics.se>

Definition in file psock.h.

`#include "uipopt.h"`
`#include "pt.h"`

Go to the source code of this file.

## Data Structures

struct | psock_buf
struct | psock
| The representation of a protosocket. More...

## Defines

#define | PSOCK_INIT(psock, buffer, buffersize)
| Initialize a protosocket.
#define | PSOCK_BEGIN(psock)
| Start the protosocket protothread in a function.
#define | PSOCK_SEND(psock, data, datalen)
| Send data.
#define | PSOCK_SEND_STR(psock, str)
| Send a null-terminated string.
#define | PSOCK_GENERATOR_SEND(psock, generator, arg)
| Generate data with a function and send it.
#define | PSOCK_CLOSE(psock)
| Close a protosocket.
#define | PSOCK_READBUF(psock)
| Read data until the buffer is full.
#define | PSOCK_READTO(psock, c)
| Read data up to a specified character.
#define | PSOCK_DATALEN(psock)
| The length of the data that was previously read.
#define | PSOCK_EXIT(psock)
| Exit the protosocket's protothread.
#define | PSOCK_CLOSE_EXIT(psock)
| Close a protosocket and exit the protosocket's protothread.
#define | PSOCK_END(psock)
| Declare the end of a protosocket's protothread.
#define | PSOCK_NEWDATA(psock)
| Check if new data has arrived on a protosocket.
#define | PSOCK_WAIT_UNTIL(psock, condition)
| Wait until a condition is true.
#define | PSOCK_WAIT_THREAD(psock, condition) PT_WAIT_THREAD(&((psock)->pt), (condition))

## Functions

u16_t | psock_datalen (struct psock *psock)
char | psock_newdata (struct psock *s)